(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Aerodynamics`InfluenceCoefficients`",{"Aerodynamics`CartesianVectors`"}];


InfluenceCoefficients::usage="is a package  containing functions to compute geometric influence coefficients for two-dimensional potential-flow point and line singularities.  Functions for velocity, velocity-potential and stream-function influence coefficients are defined for commonly used distributions of source, doublet and vortex singularities.";


UniformFlow::usage="UniformFlow[n, \[Alpha]] computes a collection of \!\(\*
StyleBox[\"n\", \"TI\"]\)\!\(\*
StyleBox[\" \", \"TI\"]\)uniform velocity vectors inclined at an angle \!\(\*
StyleBox[\"\[Alpha]\", \"TR\"]\) to the \!\(\*
StyleBox[\"x\", \"TI\"]\) axis.";


UniformFlow\[Phi]::usage="UniformFlow\[Phi][rf, \[Alpha]] computes a list of velocity-potentials at \!\(\*SubscriptBox[
StyleBox[\"r\", \"TI\"], 
StyleBox[\"f\", \"TI\"]]\) for uniform flow inclined at an angle \!\(\*
StyleBox[\"\[Alpha]\", \"TR\"]\) to the \!\(\*
StyleBox[\"x\", \"TI\"]\) axis. ";


UniformFlow\[Psi]::usage="IC\[Psi]UniformFlow[rf, \[Alpha]] computes a list of stream-functions at \!\(\*SubscriptBox[
StyleBox[\"r\", \"TI\"], 
StyleBox[\"f\", \"TI\"]]\) for uniform flow inclined at an angle \!\(\*
StyleBox[\"\[Alpha]\", \"TR\"]\) to the \!\(\*
StyleBox[\"x\", \"TI\"]\) axis. ";


DisplacementVectors::usage="DisplacementVectors[ra, rb] computes the displacement vectors between all pairs of points for the two collections of vectors, ra and rb.";


ICVortexPoint::usage = "ICVortexPoint[rF, rP] computes velocity influence coefficients at field points rF, due to vortices at rP.";


IC\[Phi]VortexPoint::usage="IC\[Phi]VortexPoint[rF, rP] computes velocity-potential influence coefficients at field points rF, due to vortices at rP.";


IC\[Psi]VortexPoint::usage="IC\[Psi]VortexPoint[rF, rP] computes stream-function influence coefficients at field points rF, due to vortices at rP.";


ICVortexConstant::usage="ICVortexConstant[rF, rP] computes velocity influence coefficients at field points rF, due to connected vortex panels of constant strength whose endpoints are located by rP.";


IC\[Phi]VortexConstant::usage="IC\[Phi]VortexConstant[rF, rP] computes velocity-potential influence coefficients at field points rF due to connected vortex panels of constant strength whose endpoints are located by rP.";


IC\[Psi]VortexConstant::usage="IC\[Psi]VortexConstant[rF, rP] computes stream-function influence coefficients at field points rF due to connected vortex panels of constant strength whose endpoints are located by rP.";


ICVortexLinear::usage="ICVortexLinear[rF, rP] computes velocity influence coefficients at field points rF, due to connected vortex panels of linearly varying strength whose endpoints are located by rP.";


IC\[Phi]VortexLinear::usage="IC\[Phi]VortexLinear[rF, rP] computes velocity-potential influence coefficients at field points rF due to connected vortex panels of linear varying strength whose endpoints are located by rP.";


IC\[Psi]VortexLinear::usage="IC\[Psi]VortexLinear[rF, rP] computes stream-function influence coefficients at field points rF due to connected vortex panels of linear varying strength whose endpoints are located by rP.";


ICSourcePoint::usage="ICSourcePoint[rF, rP] computes velocity influence coefficients at field points rF, due to point sources at rP.";


IC\[Phi]SourcePoint::usage="IC\[Phi]SourcePoint[rF, rP] computes velocity-potential influence coefficients at field points rF, due to point sources at rP.";


IC\[Psi]SourcePoint::usage="IC\[Psi]SourcePoint[rF, rP] computes stream-function influence coefficients at field points rF, due to point sources at rP.";


ICSourceConstant::usage="ICSourceConstant[rF, rP] computes velocity influence coefficients at field points rF, due to connected source panels of constant strength whose endpoints are located by rP.";


IC\[Phi]SourceConstant::usage="IC\[Phi]SourceConstant[rF, rP] computes velocity-potential influence coefficients at field points rF due to connected source panels of constant strength whose endpoints are located by rP.";


IC\[Psi]SourceConstant::usage="IC\[Psi]SourceConstant[rF, rP] computes stream-function influence coefficients at field points rF due to connected source panels of constant strength whose endpoints are located by rP.";


ICSourceLinear::usage="ICSourceLinear[rF, rP] computes velocity influence coefficients at field points rF, due to connected source panels of linearly varying strength whose endpoints are located by rP";


IC\[Phi]SourceLinear::usage="IC\[Phi]SourceLinear[rF, rP] computes velocity-potential influence coefficients at field points rF, due to connected source panels of linearly varying strength whose endpoints are located by rP.";


IC\[Psi]SourceLinear::usage="IC\[Psi]SourceLinear[rF, rP] computes stream-function influence coefficients at field points rF, due to connected source panels of linearly varying strength whose endpoints are located by rP.";


ICDoubletPoint::usage="ICDoubletPoint[rF, rP, uD] computes velocity nfluence coefficients at field points rF, due to doublets at rP. Orientation of doublets is specified by unit vectors uD.";


IC\[Phi]DoubletPoint::usage="IC\[Phi]DoubletPoint[rF, rP, uD] computes elocity-potential influence coefficients at field points rF, due to doublets at rP.  Orientation of doublets is specified by unit vectors uD.";


IC\[Psi]DoubletPoint::usage="IC\[Psi]DoubletPoint[rF, rP, uD] computes stream-function influence coefficients at field points rF, due to doublets at rP.  Orientation of doublets is specified by unit vectors uD.";


ICDoubletConstant::usage="ICDoubletConstant[rF, rP] computes velocity influence coefficients at field points rF due to connected doublet panels of constant strength whose endpoints are located by rP.";


IC\[Phi]DoubletConstant::usage="IC\[Phi]DoubletConstant[rF, rP] computes velocity-potential influence coefficients at field points rF, due to connected doublet panels of constant strength whose endpoints are located by rP.";


IC\[Psi]DoubletConstant::usage="ICDoubletConstant[rF, rP] computes stream-function influence coefficients at field points rF, due to connected doublet panels of constant strength whose endpoints are located by rP.";


ICDoubletLinear::usage="ICDoubletLinear[rF, rP] computes velocity influence coefficients at field points rF due to connected doublet panels of linearly varying strength whose end points are located by rP.";


IC\[Phi]DoubletLinear::usage="IC\[Phi]DoubletLinear[rF, rP] computes velocity-potential influence coefficients at field points rF due to connected doublet panels of linearly varying strength whose end points are located by rP.";


IC\[Psi]DoubletLinear::usage="IC\[Psi]DoubletLinear[rF, rP] computes stream-function influence coefficients at field points rF due to connected doublet panels of linearly varying strength whose end points are located by rP.";


ICDoubletQuadratic::usage="ICDoubletQuadratic[rF, rP] computes velocity influence coefficients at field points rF, due to connected doublet panels of quadratically varying strength whose endpoints are located by rP.";


IC\[Phi]DoubletQuadratic::usage="IC\[Phi]DoubletQuadratic[rF, rP] computes velocity-potential influence coefficients at field points rF due to connected doublet panels of quadratically varying strength whose endpoints are located by rP.";


IC\[Psi]DoubletQuadratic::usage="IC\[Psi]DoubletQuadratic[rF, rD] computes stream-function influence coefficients at field points rF due to connected doublet panels of quadratically varying strength whose endpoints are located by rP.";


TestArguments::usage="TestArguments[rF,rP] tests arguments for an influence-coefficient function, returning true if arguments are valid and a message if they are not.";


InfluenceCoefficients::dataType="Input arguments specifying locations of field points and singularities must be collections of two-dimensional vectors of the data type CartesianVectors.";


InfluenceCoefficients::lineSingularity="Input arguments specifying locations of line singularities must contain coordinates for at least two points.";


Begin["Aerodynamics`InfluenceCoefficients`Private`"];


Unprotect[DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletPoint,ICDoubletQuadratic,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,IC\[Phi]DoubletConstant,IC\[Phi]DoubletLinear,IC\[Phi]DoubletQuadratic,IC\[Phi]DoubletPoint,IC\[Phi]SourceConstant,IC\[Phi]SourceLinear,IC\[Phi]SourcePoint,IC\[Phi]VortexConstant,IC\[Phi]VortexLinear,IC\[Phi]VortexPoint,IC\[Psi]DoubletConstant,IC\[Psi]DoubletLinear,IC\[Psi]DoubletQuadratic,IC\[Psi]DoubletPoint,IC\[Psi]SourceConstant,IC\[Psi]SourceLinear,IC\[Psi]SourcePoint,IC\[Psi]VortexConstant,IC\[Psi]VortexLinear,IC\[Psi]VortexPoint,InfluenceCoefficients,TestArguments,UniformFlow,UniformFlow\[Phi],UniformFlow\[Psi]];


SetAttributes[{DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletQuadratic,ICDoubletPoint,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,IC\[Phi]DoubletConstant,IC\[Phi]DoubletLinear,IC\[Phi]DoubletQuadratic,IC\[Phi]DoubletPoint,IC\[Phi]SourceConstant,IC\[Phi]SourceLinear,IC\[Phi]SourcePoint,IC\[Phi]VortexConstant,IC\[Phi]VortexLinear,IC\[Phi]VortexPoint,IC\[Psi]DoubletConstant,IC\[Psi]DoubletLinear,IC\[Psi]DoubletQuadratic,IC\[Psi]DoubletPoint,IC\[Psi]SourceConstant,IC\[Psi]SourceLinear,IC\[Psi]SourcePoint,IC\[Psi]VortexConstant,IC\[Psi]VortexLinear,IC\[Psi]VortexPoint,UniformFlow,UniformFlow\[Phi],UniformFlow\[Psi]},NumericFunction]


displacementList=Compile[{{u,_Real,2},{v,_Real,2}},{Outer[Plus,u[[1]],-v[[1]]],Outer[Plus,u[[2]],-v[[2]]]}];


UniformFlow[n_Integer?Positive,\[Alpha]_]:=MakeCartesianVectors[{Table[Cos[\[Alpha]],{n}],Table[Sin[\[Alpha]],{n}]}]


UniformFlow\[Phi][rf_CartesianVectors?TwoDimQ,\[Alpha]_]:=Module[{x,z},{x,z}=Components[rf];x Cos[\[Alpha]]+z Sin[\[Alpha]]]


UniformFlow\[Psi][rf_CartesianVectors?TwoDimQ,\[Alpha]_]:=Module[{x,z},{x,z}=Components[rf];z Cos[\[Alpha]]-x Sin[\[Alpha]]]


DisplacementVectors[ra_CartesianVectors?TwoDimQ /; MatrixQ[Components[ra],MachineNumberQ],rb_CartesianVectors?TwoDimQ /; MatrixQ[Components[rb],MachineNumberQ]]:=MakeCartesianVectors[displacementList[Components[ra],Components[rb]]]


DisplacementVectors[ra_CartesianVectors?TwoDimQ,rb_CartesianVectors?TwoDimQ]:=Outer[Plus,ra,-rb]


ICVortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]VortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]VortexPoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexPoint[rf_,rs_]:=Module[{rfs,rSq,x,z},
rfs=DisplacementVectors[rf,rs];
{x,z}=Components[rfs];
rSq=rfs.rfs;
MakeCartesianVectors[{z/(2\[Pi] rSq),-(x/(2\[Pi] rSq))}]]


IC\[Phi]VortexPoint[rf_,rs_]:=Module[{r},
r=DisplacementVectors[rf,rs];
-(1/(2\[Pi]))ArcTan[r]]


IC\[Psi]VortexPoint[rf_,rs_]:=Module[{r},
r=DisplacementVectors[rf,rs];
1/(4\[Pi]) Log[r.r]]


ICVortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]VortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]VortexConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]VortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]VortexConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICVortexConstant[rf_,rs_]:=Module[{ic,rfs,r1,r2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];ic=MakeCartesianVectors[{1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1]),1/(4\[Pi]) Log[r2.r2/r1.r1]}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


IC\[Phi]VortexConstant[rf_,rs_]:=Module[{rfs,r1,r2,x,x2,z,\[Delta],\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{x,z}=Components[r1];
x2=Components[r2][[1]];
1/(2\[Pi]) (x2 ArcTan[r2]-x ArcTan[r1]+z/2 Log[r2.r2/r1.r1])]


IC\[Psi]VortexConstant[rf_,rs_]:=Module[{rfs,r1,r2,x,x2,z,\[Delta],\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Delta]=Rest[rs-RotateRight[rs]];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{x,z}=Components[r1];
x2=Components[r2][[1]];
1/(2\[Pi]) (z (ArcTan[r2]-ArcTan[r1])-1/2 (x2 Log[r2.r2]-x Log[r1.r1]))]


ICVortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]VortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]VortexLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICVortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]VortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]VortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICVortexLinear[rf_,rs_]:=Module[{ica,icax,icaz,icb,icbx,icbz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
icax=1/(2\[Pi]) (\[Theta]2-\[Theta]1);
icaz=1/(4\[Pi]) Log[r2Sq/r1Sq];
icbx=1/(2\[Pi]) (x (\[Theta]2-\[Theta]1)+z/2 Log[r2Sq/r1Sq]);
icbz=1/(2\[Pi]) ((x-x2)-z (\[Theta]2-\[Theta]1)+x/2 Log[r2Sq/r1Sq]);
ica=MakeCartesianVectors[{icax,icaz}];
icb=MakeCartesianVectors[{icbx,icbz}];
{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


IC\[Phi]VortexLinear[rf_,rs_]:=Module[{c,d,ic\[Phi]a,ic\[Phi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Phi]a=1/(2\[Pi]) (x2 \[Theta]2-x \[Theta]1+z/2 Log[r2.r2/r1.r1]);
ic\[Phi]b=1/(4\[Pi]) (d z+ (c-d^2)\[Theta]2-c \[Theta]1+x z Log[r2Sq/r1Sq]);
{ic\[Phi]a,ic\[Phi]b}]


IC\[Psi]VortexLinear[rf_,rs_]:=Module[{c,d,ic\[Psi]a,ic\[Psi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Psi]a=1/(2\[Pi]) (z (ArcTan[r2]-ArcTan[r1])-1/2 (x2 Log[r2.r2]-x Log[r1.r1]));
ic\[Psi]b=-(1/(2\[Pi]))((x d)/2-x z (\[Theta]2-\[Theta]1)+1/4 ((c-d^2)Log[r2Sq]-c Log[r1Sq]));
{ic\[Psi]a,ic\[Psi]b}]


ICSourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]SourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]SourcePoint[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourcePoint[rf_,rs_]:=Module[{rfs,rSq,x,z},
rfs=DisplacementVectors[rf,rs];
{x,z}=Components[rfs];
rSq=rfs.rfs;
MakeCartesianVectors[{x/(2\[Pi] rSq),z/(2\[Pi] rSq)}]]


IC\[Phi]SourcePoint[rf_,rs_]:=IC\[Psi]VortexPoint[rf,rs]


IC\[Psi]SourcePoint[rf_,rs_]:=-IC\[Phi]VortexPoint[rf,rs]


ICSourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]SourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]SourceConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]SourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]SourceConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICSourceConstant[rf_,rs_]:=Module[{ic,icx,icz,r1,r2,\[Delta],rfs,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
ic=MakeCartesianVectors[{-(1/(4\[Pi]))Log[r2.r2/r1.r1],1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1])}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


IC\[Phi]SourceConstant[rf_,rs_]:=IC\[Psi]VortexConstant[rf,rs]


IC\[Psi]SourceConstant[rf_,rs_]:=-IC\[Phi]VortexConstant[rf,rs]


ICSourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]SourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]SourceLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICSourceLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]SourceLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]VortexLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICSourceLinear[rf_,rs_]:=Module[{ica,icax,icaz,icb,icbx,icbz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
icax=-(1/(4\[Pi]))Log[r2.r2/r1.r1];
icaz=1/(2\[Pi]) (ArcTan[r2]-ArcTan[r1]);icbx=-(1/(2\[Pi]))((x-x2)-z (\[Theta]2-\[Theta]1)+x/2 Log[r2Sq/r1Sq]);icbz=1/(2\[Pi]) (x (\[Theta]2-\[Theta]1)+z/2 Log[r2Sq/r1Sq]);
ica=MakeCartesianVectors[{icax,icaz}];icb=MakeCartesianVectors[{icbx,icbz}];{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


IC\[Phi]SourceLinear[rf_,rs_]:=IC\[Psi]VortexLinear[rf,rs]


IC\[Psi]SourceLinear[rf_,rs_]:=-IC\[Phi]VortexLinear[rf,rs]


ICDoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


IC\[Phi]DoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


IC\[Psi]DoubletPoint[rf_,rs_,uv_]/;Head[rf]=!=CartesianVectors || Head[rs]=!=CartesianVectors || Length[rf]=!=2 || Length[rs]=!=2:=Message[InfluenceCoefficients::dataType]


ICDoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"ICDoubletPoint",3]


IC\[Phi]DoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"IC\[Phi]DoubletPoint",3]


IC\[Psi]DoubletPoint[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"IC\[Psi]DoubletPoint",3]


ICDoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


IC\[Phi]DoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


IC\[Psi]DoubletPoint[x___]:=Message[InfluenceCoefficients::argrx,"ICDoubletPoint",Length[{x}],3]


ICDoubletPoint[rf_,rs_,uv_]:=Module[{ic,rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
ic=MakeCartesianVectors[{(x z)/(\[Pi] rSq^2),-((x^2-z^2)/(2\[Pi] rSq^2))}];
Transpose[Rotate[Transpose[ic],-\[Theta]]]]


IC\[Phi]DoubletPoint[rf_,rs_,uv_]:=Module[{rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
-(z/(2\[Pi] rSq))]


IC\[Psi]DoubletPoint[rf_,rs_,uv_]:=Module[{rfs,rSq,x,z,\[Theta]},
\[Theta]=ArcTan[uv]-\[Pi]/2;
rfs=Transpose[Rotate[Transpose[DisplacementVectors[rf,rs]],\[Theta]]];
rSq=rfs.rfs;
{x,z}=Components[rfs];
-(x/(2\[Pi] rSq))]


ICDoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]DoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]DoubletConstant[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]DoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]DoubletConstant[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletConstant[rf_,rs_]:=Module[{ic,icx,icz,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{icx,icz}={z/(2\[Pi]) (1/r2Sq-1/r1Sq),-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq)};
ic=MakeCartesianVectors[{icx,icz}];
Transpose[Rotate[Transpose[ic],\[Theta]p]]]


IC\[Phi]DoubletConstant[rf_,rs_]:=Module[{rfs,r1,r2,\[Delta],\[CapitalDelta]r,\[Theta]p,\[Theta]1,\[Theta]2},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
-(1/(2\[Pi]))(\[Theta]2-\[Theta]1)]


IC\[Psi]DoubletConstant[rf_,rs_]:=Module[{rfs,r1,r2,\[Delta],\[CapitalDelta]r,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
1/(4\[Pi]) Log[r2.r2/r1.r1]]


ICDoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]DoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]DoubletLinear[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]DoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]DoubletLinear[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletLinear[rf_,rs_]:=Module[{ica,icax,icaz,icb,icbx,icbz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
icax=z/(2\[Pi]) (1/r2Sq-1/r1Sq);
icaz=-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq);ica=MakeCartesianVectors[{icax,icaz}];icbx=1/(2\[Pi]) ((z (x-x2))/r2Sq-(\[Theta]2-\[Theta]1));icbz=-(1/(2\[Pi]))((x2 (x-x2))/r2Sq+1/2 Log[r2Sq/r1Sq]);icb=MakeCartesianVectors[{icbx,icbz}];{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]]}]


IC\[Phi]DoubletLinear[rf_,rs_]:=Module[{c,d,ic\[Phi]a,ic\[Phi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Phi]a=-(1/(2\[Pi]))(\[Theta]2-\[Theta]1);
ic\[Phi]b=-(1/(2\[Pi]))(x (ArcTan[r2]-ArcTan[r1])+z/2 Log[r2.r2/r1.r1]);
{ic\[Phi]a,ic\[Phi]b}]


IC\[Psi]DoubletLinear[rf_,rs_]:=Module[{c,d,ic\[Psi]a,ic\[Psi]b,r1,r1Sq,r2,r2Sq,x,x2,z,rfs,\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Psi]a=1/(4\[Pi]) Log[r2.r2/r1.r1];
ic\[Psi]b=1/(2\[Pi]) ((x-x2)-z (ArcTan[r2]-ArcTan[r1])+x/2 Log[r2.r2/r1.r1]);
{ic\[Psi]a,ic\[Psi]b}]


ICDoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Phi]DoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


IC\[Psi]DoubletQuadratic[p___]:=Null/;!TrueQ[TestArguments[p]]


ICDoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Phi]DoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


IC\[Psi]DoubletQuadratic[rf_,rs_]/;NumberOfVectors[rs]==1:=Message[InfluenceCoefficients::lineSingularity]


ICDoubletQuadratic[rf_,rs_]:=Module[{d,ica,icax,icaz,icb,icbx,icbz,icc,iccx,iccz,x,x2,z,rfs,r1,r1Sq,r2,r2Sq,\[Delta],\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
d=x-x2;
{icax,icaz}={z/(2\[Pi]) (1/r2Sq-1/r1Sq),-(1/(2\[Pi]))(x2/r2Sq-x/r1Sq)};
ica=MakeCartesianVectors[{icax,icaz}];
{icbx,icbz}={1/(2\[Pi]) ((z (x-x2))/r2Sq-(\[Theta]2-\[Theta]1)),-(1/(2\[Pi]))((x2 (x-x2))/r2Sq+1/2 Log[r2Sq/r1Sq])};
icb=MakeCartesianVectors[{icbx,icbz}];
iccx=1/(2\[Pi]) ((z d^2)/r2Sq-2x (\[Theta]2-\[Theta]1)-z Log[r2Sq/r1Sq]);
iccz=-(1/(2\[Pi]))(2d+(x2 d^2)/r2Sq-2z (\[Theta]2-\[Theta]1)+x Log[r2Sq/r1Sq]);
icc=MakeCartesianVectors[{iccx,iccz}];
{Transpose[Rotate[Transpose[ica],\[Theta]p]],Transpose[Rotate[Transpose[icb],\[Theta]p]],Transpose[Rotate[Transpose[icc],\[Theta]p]]}]


IC\[Phi]DoubletQuadratic[rf_,rs_]:=Module[{c,d,ic\[Phi]a,ic\[Phi]b,ic\[Phi]c,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Delta],\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Phi]a=-(1/(2\[Pi]))(\[Theta]2-\[Theta]1);
ic\[Phi]b=-(1/(2\[Pi]))(x (\[Theta]2-\[Theta]1)+z/2 Log[r2Sq/r1Sq]);
ic\[Phi]c=-(1/(2\[Pi]))(z d+(x^2-z^2)(\[Theta]2-\[Theta]1)+ x z Log[r2Sq/r1Sq]);
{ic\[Phi]a,ic\[Phi]b,ic\[Phi]c}]


IC\[Psi]DoubletQuadratic[rf_,rs_]:=Module[{c,d,ic\[Psi]a,ic\[Psi]b,ic\[Psi]c,rfs,r1,r1Sq,r2,r2Sq,x,x2,z,\[Delta],\[Theta]1,\[Theta]2,\[Theta]p},
rfs=DisplacementVectors[rf,rs];
\[Theta]p=ArcTan[Rest[rs-RotateRight[rs]]];
r1=Transpose[Rotate[Drop[Transpose[rfs],{-1}],-\[Theta]p]];
r2=Transpose[Rotate[Drop[Transpose[rfs],1],-\[Theta]p]];
{r1Sq,r2Sq}={r1.r1,r2.r2};
{\[Theta]1,\[Theta]2}={ArcTan[r1],ArcTan[r2]};
{x,z}=Components[r1];
x2=Components[r2][[1]];
{c,d}={x^2-z^2,x-x2};
ic\[Psi]a=1/(4\[Pi]) Log[r2Sq/r1Sq];
ic\[Psi]b=1/(2\[Pi]) ((x-x2)-z (\[Theta]2-\[Theta]1)+x/2 Log[r2Sq/r1Sq]);
ic\[Psi]c=1/(2\[Pi]) ((x-x2)(2x-x2)-2x z (\[Theta]2-\[Theta]1)+(x^2-z^2)/2 Log[r2Sq/r1Sq]);
{ic\[Psi]a,ic\[Psi]b,ic\[Psi]c}]


TestArguments[rf_CartesianVectors?TwoDimQ,rs_CartesianVectors?TwoDimQ]:=True


TestArguments[rf_,rs_]:=Message[InfluenceCoefficients::dataType]


TestArguments[x_]/;Length[{x}]==1:=Message[InfluenceCoefficients::argr,"Singularity function",2]


TestArguments[x___]:=Message[InfluenceCoefficients::argrx,"Singularity function",Length[{x}],2]


End[];


Protect[DisplacementVectors,ICDoubletConstant,ICDoubletLinear,ICDoubletPoint,ICDoubletQuadratic,ICSourceConstant,ICSourceLinear,ICSourcePoint,ICVortexConstant,ICVortexLinear,ICVortexPoint,IC\[Phi]DoubletConstant,IC\[Phi]DoubletLinear,IC\[Phi]DoubletQuadratic,IC\[Phi]DoubletPoint,IC\[Phi]SourceConstant,IC\[Phi]SourceLinear,IC\[Phi]SourcePoint,IC\[Phi]VortexConstant,IC\[Phi]VortexLinear,IC\[Phi]VortexPoint,IC\[Psi]DoubletConstant,IC\[Psi]DoubletLinear,IC\[Psi]DoubletQuadratic,IC\[Psi]DoubletPoint,IC\[Psi]SourceConstant,IC\[Psi]SourceLinear,IC\[Psi]SourcePoint,IC\[Psi]VortexConstant,IC\[Psi]VortexLinear,IC\[Psi]VortexPoint,InfluenceCoefficients,TestArguments,UniformFlow,UniformFlow\[Phi],UniformFlow\[Psi]];


EndPackage[]
